// cl compact.cpp -link esent.lib

// sΏOS̎w
#undef JET_VERSION

#define JET_VERSION 0x0501

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <direct.h>
#include <esent.h>

// G[}N
#define Call(func) { \
       err = (func); \
       if(err < JET_errSuccess) { \
       goto HandleError; \
       } \
} \

// ȂǃR[obN֐
JET_ERR JET_API status_callback(
                       JET_SESID  sesid,
                       JET_SNP snp,
                       JET_SNT snt,
                       void* pv
)
{
	return JET_errSuccess;
}

int main(int argc, char * argv[])
{

	JET_ERR err;
	JET_INSTANCE instance = JET_instanceNil;
	JET_SESID sesid = JET_sesidNil;
	char logdir[32];
	time_t now;

	if (argc < 3) {
		fprintf(stderr, "compact target_db compacted_db\n");
		return 2;
	}
	
	sprintf(logdir, ".\\log_%0ld", time(&now));
	_mkdir(logdir);

	// ESENT̏sB
	unsigned long pagesize;

	Call(JetGetDatabaseFileInfo(argv[1], &pagesize, sizeof(unsigned long), JET_DbInfoPageSize));
	printf("%lu\n", pagesize);

	Call(JetSetSystemParameter(&instance, JET_sesidNil, JET_paramDatabasePageSize, pagesize, NULL));
	printf("ESE DB page size set.\n");

	Call(JetCreateInstance(&instance, "instance"));
	printf("ESE DB instance created.\n");

	Call(JetSetSystemParameter(&instance, JET_sesidNil, JET_paramBaseName, 0, "CPe"));
	printf("ESE DB JET_paramBaseName set.\n");

	Call(JetSetSystemParameter(&instance, JET_sesidNil, JET_paramLogFileSize, 8192, NULL));
	printf("ESE DB JET_paramLogFileSize set.\n");

	Call(JetSetSystemParameter(&instance, JET_sesidNil, JET_paramLogFilePath, 0, logdir));
	printf("ESE DB JET_paramLogFilePath set.\n");

	Call(JetSetSystemParameter(&instance, JET_sesidNil, JET_paramCircularLog, 1, NULL));
	printf("ESE DB JET_paramCircularLog set.\n");

	Call(JetInit(&instance));
	printf("ESE DB Initialized.\n");

	JetBeginSession(instance, &sesid, 0, 0);
	printf("ESE DB Session Begin.\n");

	// ZbVɑ΂Af[^x[XA^b`B
	// JetCompact̎sɕKv
	Call(JetAttachDatabase(sesid, argv[1], 0));
	printf("ESE DB Attached.\n");

	printf("Target:%s\nDestination:%s\n", argv[1], argv[2]);

	// f[^x[XœKB
	Call(JetCompact(
		sesid,
		argv[1],
		argv[2],
		status_callback,
		NULL,
		// 0));
		JET_bitCompactStats));

	// ZbṼN[Abv
	if (sesid != JET_sesidNil) {
		JetEndSession(sesid, JET_bitNil);
	}
	if (instance != JET_instanceNil) {
		JetTerm(instance);
	}

	   return 0;

HandleError:

	   printf("ESENT error %d\n", err);

	   return 1;

}
